 //
//  OFAViewController.m
//  MicroLifeDeviceSDK-Dome
//
//  Created by WiFi@ on 2018/6/5.
//  Copyright © 2018年 WiFi@MBP. All rights reserved.
//

#import "OFAViewController.h"

@implementation OFAViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    [self connect3GBP];
    [self connect4GBP];
    [self connectTemperature];
    [self connectOxygen];
    [self connectWeight];
    [self connectBloodSugar];
//    kWeakSelf(self)
//    [self.sdk device:@[self.bp3g,self.bp4g,self.temperature,self.oxygen,self.weight,self.bloodSugar]];
//    [self.sdk getDidUpdateStateBlock:^(CBManagerState state) {
//        NSString *log = [NSString stringWithFormat:@"DidUpdateState：%ld",(long)state];
//        [weakself addLogWhitText:log];
//    }];
//    [self.sdk getScanDeviceBlock:^(id  _Nonnull device) {
//        NSString *log = [NSString stringWithFormat:@"ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
//        [weakself addLogWhitText:log];
//    } CancelScanBlock:^() {
//        [weakself addLogWhitText:@"Cancel Scan"];
//        [weakself.sdk startScan];
//    }];
//    [self.sdk getConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
//        [weakself connectDeviceInfo:device PeripheralState:state];
//    } CancelAllDevicesConnectionBlock:^{
//        [weakself addLogWhitText:@"Cancel All Devices Connection"];
//        [weakself.sdk startScan];
//    }];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma device
- (void)connect3GBP {
    kWeakSelf(self)
    self.bp3g = [MicroLife3GBP shareWhithAuthorizationkey:SDKkey_BPM];
    [self.bp3g getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"bp3g DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"bp3g ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"bp3g Cancel Scan"];
        [weakself.bp3g startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"bp3g Cancel All Devices Connection"];
        [weakself.bp3g startScan];
    }];
    [self.bp3g deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.bp3g];
        [weakself addLogWhitText:log];
    }];
    [self.bp3g getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.bp3g CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMD3GReadUserAndVersionData:
                [weakself.bp3g readHistorys];
                break;
            case CMD3GReadHistorys:
                [weakself.bp3g disconnect];
                break;
            default:
                break;
        }
    }];
}

- (void)connect4GBP {
    kWeakSelf(self)
    self.bp4g = [MicroLife4GBP shareWhithAuthorizationkey:SDKkey_BPM];
    [self.bp4g addDeviceModel:@[@"6024N"]];
    [self.bp4g getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"bp4g DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"bp4g ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"bp4g Cancel Scan"];
        [weakself.bp4g startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"bp4g Cancel All Devices Connection"];
        [weakself.bp4g startScan];
    }];
    [self.bp4g deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.bp4g];
        [weakself addLogWhitText:log];
    }];
    [self.bp4g getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.bp4g CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMD4GReadUserAndVersionData:
                [weakself.bp4g readHistorys];
                break;
            case CMD4GReadHistorys:
                [weakself.bp4g disconnect];
                break;
            default:
                break;
        }
    }];
}

- (void)connectTemperature {
    kWeakSelf(self)
    self.temperature = [MicroLifeTemperature shareWhithAuthorizationkey:SDKkey_BT];
    [self.temperature getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"temperature DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"temperature ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"temperature Cancel Scan"];
        [weakself.temperature startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"temperature Cancel All Devices Connection"];
        [weakself.temperature startScan];
    }];
    [self.temperature deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.temperature];
        [weakself addLogWhitText:log];
    }];
    [self.temperature getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.temperature CMD:CMD Model:model Error:error];
    }];
}

- (void)connectOxygen {
    kWeakSelf(self)
    self.oxygen = [MicroLifeOxygen shareWhithAuthorizationkey:SDKkey_SPO2];
    [self.oxygen getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"oxygen DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"oxygen ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"oxygen Cancel Scan"];
        [weakself.oxygen startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"oxygen Cancel All Devices Connection"];
        [weakself.oxygen startScan];
    }];
    [self.oxygen deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.oxygen];
        [weakself addLogWhitText:log];
    }];
    [self.oxygen getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.oxygen CMD:CMD Model:model Error:error];
    }];
}

- (void)connectWeight {
    kWeakSelf(self)
    self.weight = [MicroLifeWeight shareWhithAuthorizationkey:SDKkey_WEI];
    [self.weight getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"weight DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"weight ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"weight Cancel Scan"];
        [weakself.weight startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"weight Cancel All Devices Connection"];
        [weakself.weight startScan];
    }];
    [self.weight deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.weight];
        [weakself addLogWhitText:log];
    }];
    [self.weight getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.weight CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDWeightWakeUpScale:
                [weakself addLogWhitText:@"WakeUp Scale"];
                [weakself.weight writeUserData:weakself.currUser.weightUserID Age:weakself.currUser.age.integerValue Gender:weakself.currUser.gender Height:weakself.currUser.height.integerValue RoleType:weakself.currUser.roleType Weight:weakself.currUser.weight.floatValue Resistance:weakself.currUser.resistance.integerValue];
                [weakself.weight readHistorys];
                break;
            case CMDWeightSleepScale:
                [weakself addLogWhitText:@"Sleep Scale"];
                [weakself.weight disconnect];
                break;
            case CMDWeightMeasurementResult:
                [weakself addLogWhitText:@"Measurement Result"];
                weakself.currUser.resistance = ((MicroLifeBodyFat *)model).resistance;
                [weakself saveNSUserDefaults:weakself.currUser.resistance Key:@"resistance"];
                break;
            case CMDWeightReadHistorys:
                [weakself addLogWhitText:@"Read Historys"];
                weakself.currUser.resistance = ((MicroLifeBodyFat *)model).resistance;
                [weakself saveNSUserDefaults:weakself.currUser.resistance Key:@"resistance"];
                break;
            case CMDWeightUpdateUserInfo:
                [weakself addLogWhitText:@"Update UserInfo"];
                break;
            case CMDWeightClearAllUserInfo:
                [weakself addLogWhitText:@"Clear All UserInfo"];
                break;
            case CMDWeightNoMoreOfflineData:
                [weakself addLogWhitText:@"No More OfflineData"];
                break;
            case CMDWeightLowPower:
                [weakself addLogWhitText:@"Low Power"];
                break;
            case CMDWeightSyncSystemClock:
                [weakself addLogWhitText:@"Sync System Clock"];
                break;
            default:
                break;
        }
    }];
}

- (void)connectBloodSugar {
    kWeakSelf(self)
    self.dataLength = 1;
    self.bloodSugar = [MicroLifeBloodSugar shareWhithAuthorizationkey:@""];
    [self.bloodSugar getDidUpdateStateBlock:^(CBManagerState state) {
        NSString *log = [NSString stringWithFormat:@"bloodSugar DidUpdateState：%ld",(long)state];
        [weakself addLogWhitText:log];
    } ScanDeviceBlock:^(id  _Nonnull device) {
        NSString *log = [NSString stringWithFormat:@"bloodSugar ScanDevice Name：%@ UUID：%@ mac：%@",[device name],[device UUID],[device mac]];
        [weakself addLogWhitText:log];
    } CancelScanBlock:^{
        [weakself addLogWhitText:@"bloodSugar Cancel Scan"];
        [weakself.bloodSugar startScan];
    } ConnectDeviceStateBlock:^(id  _Nonnull device, CBCentralManager * _Nonnull central, CBPeripheral * _Nonnull peripheral, CBPeripheralState state, NSError * _Nonnull error) {
        [weakself connectDeviceInfo:device PeripheralState:state];
    } CancelAllDevicesConnectionBlock:^{
        [weakself addLogWhitText:@"bloodSugar Cancel All Devices Connection"];
        [weakself.bloodSugar startScan];
    }];
    [self.bloodSugar deviceConnectedBlock:^{
        NSString *log = [NSString stringWithFormat:@"%@ Connected",weakself.bloodSugar];
        [weakself addLogWhitText:log];
    }];
    [self.bloodSugar getReadDataModelBlock:^(NSInteger CMD, id  _Nonnull model, NSError * _Nonnull error) {
        [weakself log:weakself.bloodSugar CMD:CMD Model:model Error:error];
        switch (CMD) {
            case CMDBloodSugarReadDataLength:
            case CMDBloodSugarReadDeviceName:
            case CMDBloodSugarReadFWVersion:
            case CMDBloodSugarBLEStatus:
            case CMDBloodSugarReadData:
            case CMDBloodSugarReadNewData:
            case CMDBloodSugarReadHistorysData:
            case CMDBloodSugarReadLastData:
            case CMDBloodSugarDisconnect:
            case CMDBloodSugarReadDateTime:
                break;
            default:
                break;
        }
    }];
}

@end
